import { Component } from 'vue';

declare type Lazy<T> = () => Promise<T>;
interface Route {
    name?: string;
    path: string;
    props?: boolean;
    component: Component | Lazy<Component>;
    children?: Route[];
    meta?: Record<string, unknown>;
}
interface Options {
    /**
     * @default ["vue", "md"]
     */
    extensions: string[];
    /**
     * @default "pages"
     */
    pagesDir: string;
    extendRoute?: (route: Route, parent: Route | undefined) => Route | void;
}
declare type UserOptions = Partial<Options>;
declare function generateRoutes(filesPath: Record<string, Lazy<Component>>, userOptions?: UserOptions): Route[];

export { UserOptions, generateRoutes };
